package cd.casic.ci.api;


import cd.casic.ci.process.dal.req.variable.VariableReq;
import cd.casic.ci.process.dal.resp.variable.VariableResp;
import cd.casic.framework.commons.pojo.CommonResult;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import jakarta.validation.Valid;
import jakarta.validation.constraints.NotNull;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.List;

/**
 * @pi.protocol: http
 * @pi.groupName: 流水线变量控制器
 */
@RestController
@RequestMapping("/pipelineVariable")
public class VariableController {
    /**
     * @pi.name:创建流水线变量
     * @pi.path:/pipelineVariable/createVariable
     * @pi.methodType:post
     * @pi.request-type:json
     * @pi.param: model=variable
     */
    @RequestMapping(path="/createVariable",method = RequestMethod.POST)
    public CommonResult<String> createVariable(@RequestBody @NotNull @Valid VariableReq variable){
        String variableId = "";
//        String variableId = variableServer.createVariable(variable);
        return CommonResult.success(variableId);
    }

    /**
     * @pi.name:删除流水线变量
     * @pi.path:/pipelineVariable/deleteVariable
     * @pi.methodType:post
     * @pi.request-type: formdata
     * @pi.param: name=varId;dataType=string;value=varId;
     */
    @RequestMapping(path="/deleteVariable",method = RequestMethod.POST)
    public CommonResult<String> deleteVariable( @NotNull  String varId){
//        variableServer.deleteVariable(varId);
        return CommonResult.success("");
    }

    /**
     * @pi.name:更新流水线变量
     * @pi.path:/pipelineVariable/createVariable
     * @pi.methodType:post
     * @pi.request-type:json
     * @pi.param: model=variable
     */
    @RequestMapping(path="/updateVariable",method = RequestMethod.POST)
    public CommonResult<String> updateVariable(@RequestBody @NotNull @Valid VariableReq variable){
//        variableServer.updateVariable(variable);
        return CommonResult.success("");
    }

    /**
     * @pi.name:查询流水线任务变量
     * @pi.path:/pipelineVariable/findAllVariable
     * @pi.methodType:post
     * @pi.request-type: formdata
     * @pi.param: name=taskId;dataType=string;value=任务id;
     */
    @RequestMapping(path="/findAllVariable",method = RequestMethod.POST)
    public CommonResult<List<VariableResp>> findAllVariable(@NotNull String taskId){
//        List<VariableResp> allVariable = variableServer.findAllVariable(taskId);
        String varListStr = "[\n" +
                "  {\n" +
                "    \"varId\": \"04b629ce9234\",\n" +
                "    \"createTime\": \"2025-05-10 14:25:24\",\n" +
                "    \"varType\": \"str\",\n" +
                "    \"type\": 1,\n" +
                "    \"taskId\": \"a69119cfbbde\",\n" +
                "    \"pipelineId\": null,\n" +
                "    \"varKey\": \"testVal\",\n" +
                "    \"varValue\": \"123\",\n" +
                "    \"varValues\": null,\n" +
                "    \"valueList\": null\n" +
                "  }\n" +
                "]";
        JSONArray objects = JSON.parseArray(varListStr);
        List<VariableResp> allVariable = new ArrayList<>(objects.size());
        for (int i = 0; i < objects.size(); i++) {
            VariableResp object = objects.getObject(i, VariableResp.class);
            allVariable.add(object);
        }
        return CommonResult.success(allVariable);
    }
}
